export default function once(emitter, name, { signal } = {}
// @ts-ignore
) {
    return new Promise((resolve, reject) => {
        function cleanup() {
            signal === null || signal === void 0 ? void 0 : signal.removeEventListener('abort', cleanup);
            // @ts-ignore
            emitter.removeListener(name, onEvent);
            emitter.removeListener('error', onError);
        }
        function onEvent(...args) {
            cleanup();
            resolve(args);
        }
        function onError(err) {
            cleanup();
            reject(err);
        }
        signal === null || signal === void 0 ? void 0 : signal.addEventListener('abort', cleanup);
        // @ts-ignore
        emitter.on(name, onEvent);
        emitter.on('error', onError);
    });
}
//# sourceMappingURL=index.js.map